diff --git a/Makefile.objs b/Makefile.objs
index 36005bb..614bcaf 100644
--- a/Makefile.objs
+++ b/Makefile.objs
@@ -297,7 +297,7 @@ hw-obj-$(CONFIG_SOUND) += $(sound-obj-y)
 9pfs-nested-$(CONFIG_VIRTFS) = virtio-9p.o virtio-9p-debug.o
 9pfs-nested-$(CONFIG_VIRTFS) +=  virtio-9p-local.o virtio-9p-xattr.o
 9pfs-nested-$(CONFIG_VIRTFS) +=   virtio-9p-xattr-user.o virtio-9p-posix-acl.o
-9pfs-nested-$(CONFIG_VIRTFS) += virtio-9p-coth.o cofs.o
+9pfs-nested-$(CONFIG_VIRTFS) += virtio-9p-coth.o cofs.o codir.o
 
 hw-obj-$(CONFIG_REALLY_VIRTFS) += $(addprefix 9pfs/, $(9pfs-nested-y))
 $(addprefix 9pfs/, $(9pfs-nested-y)): QEMU_CFLAGS+=$(GLIB_CFLAGS)
diff --git a/hw/9pfs/codir.c b/hw/9pfs/codir.c
new file mode 100644
index 0000000..adca50c
--- /dev/null
+++ b/hw/9pfs/codir.c
@@ -0,0 +1,135 @@
+
+/*
+ * Virtio 9p backend
+ *
+ * Copyright IBM, Corp. 2011
+ *
+ * Authors:
+ *  Aneesh Kumar K.V <aneesh.kumar@linux.vnet.ibm.com>
+ *
+ * This work is licensed under the terms of the GNU GPL, version 2.  See
+ * the COPYING file in the top-level directory.
+ *
+ */
+
+#include "fsdev/qemu-fsdev.h"
+#include "qemu-thread.h"
+#include "qemu-coroutine.h"
+#include "virtio-9p-coth.h"
+
+typedef struct V9fsThReaddirState {
+    int err;
+    V9fsState *s;
+    V9fsFidState *fidp;
+    struct dirent *dent;
+    V9fsRequest request;
+} V9fsThReaddirState;
+
+static void v9fs_th_do_readdir(V9fsRequest *request)
+{
+    V9fsThReaddirState *vsp = container_of(request, V9fsThReaddirState,
+                                           request);
+    errno = 0;
+    vsp->dent = vsp->s->ops->readdir(&vsp->s->ctx, vsp->fidp->fs.dir);
+    if (!vsp->dent && errno) {
+        vsp->err = -errno;
+    } else {
+        vsp->err = 0;
+    }
+}
+
+int v9fs_co_readdir(V9fsState *s, V9fsFidState *fidp, struct dirent **dent)
+{
+    V9fsThReaddirState vs;
+    vs.s = s;
+    vs.fidp = fidp;
+    vs.request.func = v9fs_th_do_readdir;
+    vs.request.coroutine = qemu_coroutine_self();
+    v9fs_qemu_submit_request(&vs.request);
+    qemu_coroutine_yield();
+    *dent = vs.dent;
+    return vs.err;
+}
+
+typedef struct V9fsThTelldirState {
+    off_t err;
+    V9fsState *s;
+    V9fsFidState *fidp;
+    V9fsRequest request;
+} V9fsThTelldirState;
+
+
+static void v9fs_th_do_telldir(V9fsRequest *request)
+{
+    V9fsThTelldirState *vsp = container_of(request, V9fsThTelldirState,
+                                           request);
+    errno = 0;
+    vsp->err = vsp->s->ops->telldir(&vsp->s->ctx, vsp->fidp->fs.dir);
+    if (vsp->err < 0) {
+        vsp->err = -errno;
+    }
+}
+
+off_t v9fs_co_telldir(V9fsState *s, V9fsFidState *fidp)
+{
+    V9fsThTelldirState vs;
+    vs.s = s;
+    vs.fidp = fidp;
+    vs.request.func = v9fs_th_do_telldir;
+    vs.request.coroutine = qemu_coroutine_self();
+    v9fs_qemu_submit_request(&vs.request);
+    qemu_coroutine_yield();
+    return vs.err;
+}
+
+typedef struct V9fsThSeekdirState {
+    off_t offset;
+    V9fsState *s;
+    V9fsFidState *fidp;
+    V9fsRequest request;
+} V9fsThSeekdirState;
+
+static void v9fs_th_do_seekdir(V9fsRequest *request)
+{
+    V9fsThSeekdirState *vsp = container_of(request, V9fsThSeekdirState,
+                                           request);
+    vsp->s->ops->seekdir(&vsp->s->ctx, vsp->fidp->fs.dir, vsp->offset);
+}
+
+void v9fs_co_seekdir(V9fsState *s, V9fsFidState *fidp, off_t offset)
+{
+    V9fsThSeekdirState vs;
+    vs.s = s;
+    vs.fidp = fidp;
+    vs.offset = offset;
+    vs.request.func = v9fs_th_do_seekdir;
+    vs.request.coroutine = qemu_coroutine_self();
+    v9fs_qemu_submit_request(&vs.request);
+    qemu_coroutine_yield();
+    return;
+}
+
+typedef struct V9fsThRewindirState {
+    V9fsState *s;
+    V9fsFidState *fidp;
+    V9fsRequest request;
+} V9fsThRewinddirState;
+
+static void v9fs_th_do_rewinddir(V9fsRequest *request)
+{
+    V9fsThRewinddirState *vsp = container_of(request, V9fsThRewinddirState,
+                                             request);
+    vsp->s->ops->rewinddir(&vsp->s->ctx, vsp->fidp->fs.dir);
+}
+
+void v9fs_co_rewinddir(V9fsState *s, V9fsFidState *fidp)
+{
+    V9fsThSeekdirState vs;
+    vs.s = s;
+    vs.fidp = fidp;
+    vs.request.func = v9fs_th_do_rewinddir;
+    vs.request.coroutine = qemu_coroutine_self();
+    v9fs_qemu_submit_request(&vs.request);
+    qemu_coroutine_yield();
+    return;
+}
diff --git a/hw/9pfs/virtio-9p-coth.h b/hw/9pfs/virtio-9p-coth.h
index d0b856e..4d34098 100644
--- a/hw/9pfs/virtio-9p-coth.h
+++ b/hw/9pfs/virtio-9p-coth.h
@@ -50,4 +50,9 @@ extern void v9fs_qemu_submit_request(V9fsRequest *req);
 
 extern int v9fs_co_readlink(V9fsState *, V9fsString *,
                             V9fsString *, ssize_t *);
+extern int v9fs_co_readdir(V9fsState *, V9fsFidState *,
+                           struct dirent **);
+extern off_t v9fs_co_telldir(V9fsState *, V9fsFidState *);
+extern void v9fs_co_seekdir(V9fsState *, V9fsFidState *, off_t);
+extern void v9fs_co_rewinddir(V9fsState *, V9fsFidState *);
 #endif